//+-------------------------------------------------------------------------------------------------+
//| ServicesMT.h:    "ServicesMT.dll"     .|
//| Copyright  2010,   (Zhunko)                                                          |
//| e-mail: vadim@zhunko.ru                                                 16.10.2010 - 13.05.2014 |
//+-------------------------------------------------------------------------------------------------+
//|  "ServicesMT.dll"  293      .        |
//+-------------------------------------------------------------------------------------------------+
//| ,      ,                   |
//|  . : " ..." .                                       |
//|   :                                                                      |
//|   ServiceInitPathA(), ServiceInitPathW(), ServiceInitProcessId(),                               |
//|   ServiceGetAllSymbolsMA(), ServiceGetAllSymbolsMW(),                                           |
//|   ServiceOpenChartA(), ServiceOpenChartW(),                                                     |
//|   ServiceOpenChartSetIndexTfA(), ServiceOpenChartSetIndexTfW(),                                 |
//|   ServiceOpenChartSetPeriodA(), ServiceOpenChartSetPeriodW(),                                   |
//|   ServiceOpenChartSetTfA(), ServiceOpenChartSetTfW(),                                           |
//|   ServiceTerminalBoxCloseByHandle(),                                                            |
//|   ServiceTerminalBoxCloseByNameA(), ServiceTerminalBoxCloseByNameW(),                           |
//|   ServiceTerminalSetTabByIndex(),                                                               |
//|   ServiceTerminalSetTabByNameA(), ServiceTerminalSetTabByNameW(),                               |
//|   ServiceMailboxDelete(),                                                                       |
//|   ServiceMailboxGetLineA(), ServiceMailboxGetLineW(),                                           |
//|   ServiceMailboxGetTime(), ServiceMailboxOpen(), ServiceMailboxRows(),                          |
//|   ServiceNewsColumns(), ServiceNewsGetCategoryA(), ServiceNewsGetCategoryW(),                   |
//|   ServiceNewsGetStringTimeA(), ServiceNewsGetStringTimeW(),                                     |
//|   ServiceNewsGetLineA(), ServiceNewsGetLineW(),                                                 |
//|   ServiceNewsGetTime(), ServiceNewsGetThemeA(), ServiceNewsGetThemeW(),                         |
//|   ServiceNewsOpen(), ServiceNewsRows(),                                                         |
//|   ServiceDeleteIndicatorsByNameMA(), ServiceDeleteIndicatorsByNameMW(),                         |
//|   ServiceLoginApplyA(), ServiceLoginApplyW().                                                   |
//+-------------------------------------------------------------------------------------------------+

#ifndef EXPFUNC
 #define EXPFUNC(type)   __declspec(dllexport) type __stdcall
#endif

#ifndef __MT_MACROS_H__
 //====   4. ==============================================================================================================================================
 #define LL_ENGLISH                    0x7D00 // 32000  .
 #define LL_ARABIC                     0x7D01 // 32001  .
 #define LL_BULGARIAN                  0x7D02 // 32002  .
 #define LL_CHINESE_SIMPLE             0x7D03 // 32003  () .
 #define LL_CHINESE_TRADITIONAL        0x7D04 // 32004  () .
 #define LL_CROATIAN                   0x7D05 // 32005  .
 #define LL_CZECH                      0x7D06 // 32006  .
 #define LL_DANISH                     0x7D07 // 32007  .
 #define LL_DUTCH                      0x7D08 // 32008  .
 #define LL_ESTONIAN                   0x7D09 // 32009  .
 #define LL_FARSI                      0x7D1A // 32010 .
 #define LL_FRENCH                     0x7D1B // 32011  .
 #define LL_GERMAN                     0x7D1C // 32012  .
 #define LL_GREEK                      0x7D1D // 32013  .
 #define LL_HEBREW                     0x7D1E // 32014 .
 #define LL_HUNGARIAN                  0x7D1F // 32015  .
 #define LL_INDONESIAN                 0x7D10 // 32016  .
 #define LL_ITALIAN                    0x7D11 // 32017  .
 #define LL_JAPANESE                   0x7D12 // 32018  .
 #define LL_KOREAN                     0x7D13 // 32019  .
 #define LL_LATVIAN                    0x7D14 // 32020  .
 #define LL_LITHUANIAN                 0x7D15 // 32021  .
 #define LL_MONGOLIAN                  0x7D16 // 32022  .
 #define LL_POLISH                     0x7D17 // 32023  .
 #define LL_PORTUGUESE                 0x7D18 // 32024  .
 #define LL_RUSSIAN                    0x7D19 // 32025  .
 #define LL_SERBIAN                    0x7D1A // 32026  .
 #define LL_SLOVAK                     0x7D1B // 32027  .
 #define LL_SPANISH                    0x7D1C // 32028  .
 #define LL_SWEDISH                    0x7D1D // 32029  .
 #define LL_TURKISH                    0x7D1E // 32030  .
 #define LL_VIETNAMESE                 0x7D1F // 32031  .

 //====     "ServiceLoadingQuotes()". =======================================================================================================
 #define MLQ_STOP_TF                        0 //           .
 #define MLQ_CONTINUED                      1 //      .
 #define MLQ_FINISH                         2 //   .

 //====      "ServiceSetViewChart()". ===================================================================================================
 #define VS_BARS                            0 // .
 #define VS_CANDLES                         1 //  .
 #define VS_LINE                            2 // .

 //====    . ===================================================================================================================================
 #define PC_OK                         0x0001 //  "OK".
 #define PC_CANCEL                     0x0002 //  "".
 #define PC_RESET                      0x3021 //  "".
 #define PC_TAB_CONTROL                0x3020 //  .

 //----  "". ----------------------------------------------------------------------------------------------------------------------------------------------------
 #define PC_COLOR_SCHEME               0x0503 //  .
 #define PC_COLOR_BACKGROUND           0x041A // .
 #define PC_COLOR_FOREGROUND           0x0421 // .
 #define PC_COLOR_GRID                 0x0483 // .
 #define PC_COLOR_BAR_UP               0x041C //  .
 #define PC_COLOR_BAR_DOWN             0x041B //  .
 #define PC_COLOR_BULL_CANDLE          0x041E //  .
 #define PC_COLOR_BEAR_CANDLE          0x041D //  .
 #define PC_COLOR_LINE_GRAPH           0x049B // .
 #define PC_COLOR_LINE_VOLUMES         0x0569 // .
 #define PC_COLOR_ASK_LINE             0x03F7 //  ASK.
 #define PC_COLOR_STOP_LEVELS          0x0535 //  .

 //----  "". ---------------------------------------------------------------------------------------------------------------------------------------------------
 #define PC_COMMON_OFFLINE_CHART       0x04E9 //  .
 #define PC_COMMON_FOREGROUND          0x04E4 //  .
 #define PC_COMMON_SHIFT               0x04EF //  .
 #define PC_COMMON_AUTOSCROLL          0x04ED //  .
 #define PC_COMMON_BAR_CHART           0x04E1 //   - .
 #define PC_COMMON_CANDLESTICKS        0x04E2 //   -  .
 #define PC_COMMON_LINE_CHART          0x04E6 //   - .
 #define PC_COMMON_OHLC                0x04EA //  OHLC.
 #define PC_COMMON_ASK                 0x04E0 //   ASK.
 #define PC_COMMON_PERIOD_SEPARATORS   0x04EE //   .
 #define PC_COMMON_GRID                0x04E5 //  .
 #define PC_COMMON_VOLUMES             0x04F0 //  .
 #define PC_COMMON_OBJECT_DESCRIPTIONS 0x04E3 //   .
 #define PC_COMMON_SCALE_FIX_1_TO_1    0x04EC //   1:1.
 #define PC_COMMON_SCALE_FIX           0x04EB //  .
 #define PC_COMMON_FIXED_MAX           0x04E7 // .
 #define PC_COMMON_FIXED_MIN           0x04E8 // .

 //----        . ----------------------------------------------------------------------------------------------
 #define STATUS_UNKNOWN                     0 //   .
 #define STATUS_SUCCESS                     1 //     .           .
 #define STATUS_NO_CONNECT                  2 //  .
 #define STATUS_INVALID_ACCOUNT             3 //  .
 #define STATUS_COMMON_ERROR                4 //  .
 //=========================================================================================================================================================================
#endif

//
// 1.   .
//
// 1.1.    .   TRUE,    ,  - FALSE.
EXPFUNC(BOOL) ServiceCheckAccount();
//==============================================================================================================================================================================================================================================================
// 1.2.1.          .       .      .
//            .             .  .    ANSI-.
EXPFUNC(VOID) ServiceInitPathA(LPCSTR szFullPath); //        4.    ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 1.2.2.          .       .      .
//            .             .  .    UNICODE-.
EXPFUNC(VOID) ServiceInitPathW(LPCWSTR szFullPath); //        4.    ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 1.2.3.          .       .      .
//            .             .  .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceInitPath  ServiceInitPathW
#else
 #define ServiceInitPath  ServiceInitPathA
#endif
//==============================================================================================================================================================================================================================================================
// 1.3.       .       .      .
//          .             .  .
EXPFUNC(VOID) ServiceInitProcessId(DWORD dwProcessId); //  .      NULL.
//
// 2.       4.
//
// 2.1.    4.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 2.1.1.1.   ANSI-  .
EXPFUNC(LPSTR) ServiceCurrentAccountNameA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.1.2.   UNICODE-  .
EXPFUNC(LPWSTR) ServiceCurrentAccountNameW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.1.3.         .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceCurrentAccountName  ServiceCurrentAccountNameW
#else
 #define ServiceCurrentAccountName  ServiceCurrentAccountNameA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.2.     .
EXPFUNC(INT) ServiceCurrentAccountNum();
//==============================================================================================================================================================================================================================================================
// 2.1.3.1.   ANSI-  .
EXPFUNC(LPSTR) ServiceCurrentServerA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.3.2.   UNICODE-  .
EXPFUNC(LPWSTR) ServiceCurrentServerW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.3.3.         .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceCurrentServer  ServiceCurrentServerW
#else
 #define ServiceCurrentServer  ServiceCurrentServerA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.4.      4.
EXPFUNC(INT) ServiceGetProcessId();
//==============================================================================================================================================================================================================================================================
// 2.1.5.       4.
EXPFUNC(HWND) ServiceHandleMT();
//==============================================================================================================================================================================================================================================================
// 2.1.6.1.   ANSI- .    "MetaTrader 4"  "MetaTrader 5".
EXPFUNC(LPSTR) ServiceNameMTA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.6.2.   UNICODE- .    "MetaTrader 4"  "MetaTrader 5".
EXPFUNC(LPWSTR) ServiceNameMTW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.6.3.        .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceNameMT  ServiceNameMTW
#else
 #define ServiceNameMT  ServiceNameMTA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.7.1.    ANSI-  .
EXPFUNC(LPSTR) ServicePathMTA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.7.2.    UNICODE-  .
EXPFUNC(LPWSTR) ServicePathMTW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.7.3.          .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServicePathMT  ServicePathMTW
#else
 #define ServicePathMT  ServicePathMTA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.8.1.    ANSI-          .
EXPFUNC(LPSTR) ServicePathDataMTA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.8.2.    UNICODE-          .
EXPFUNC(LPWSTR) ServicePathDataMTW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.8.3.                  .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServicePathDataMT  ServicePathDataMTW
#else
 #define ServicePathDataMT  ServicePathDataMTA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.9.1.    ANSI-    4     .
EXPFUNC(LPSTR) ServicePathDirectoryMTA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.9.2.    UNICODE-    4     .
EXPFUNC(LPWSTR) ServicePathDirectoryMTW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.9.3.        4         .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServicePathDirectoryMT  ServicePathDirectoryMTW
#else
 #define ServicePathDirectoryMT  ServicePathDirectoryMTA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.10.1.    ANSI-     4     .
EXPFUNC(LPSTR) ServicePathServerA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.10.2.    UNICODE-     4     .
EXPFUNC(LPWSTR) ServicePathServerW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.10.3.         4         .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServicePathServer  ServicePathServerW
#else
 #define ServicePathServer  ServicePathServerA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.11.         .
//           STATUS_UNKNOWN             .
//           STATUS_SUCCESS               .           .
//           STATUS_NO_CONNECT         .
//           STATUS_INVALID_ACCOUNT    .
//           STATUS_COMMON_ERROR       .
EXPFUNC(INT) ServiceStatusConnectId();
//==============================================================================================================================================================================================================================================================
// 2.1.12.1.   ANSI-      .
EXPFUNC(LPSTR) ServiceStatusConnectTextA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.12.2.   UNICODE-      .
EXPFUNC(LPWSTR) ServiceStatusConnectTextW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.12.3.             .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceStatusConnectText  ServiceStatusConnectTextW
#else
 #define ServiceStatusConnectText  ServiceStatusConnectTextA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.13.1.   ANSI- c   4. : "4.0.0.445".
EXPFUNC(LPSTR) ServiceVersionA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.13.2.   UNICODE- c   4. : "4.0.0.445".
EXPFUNC(LPWSTR) ServiceVersionW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.13.3.    c   4    . : "4.0.0.445".
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceVersion  ServiceVersionW
#else
 #define ServiceVersion  ServiceVersionA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.14.1.      4.
EXPFUNC(INT) ServiceVersionBuild();
//==============================================================================================================================================================================================================================================================
// 2.1.15.1.   ANSI-      4   "yyyy.mm.dd".
EXPFUNC(LPSTR) ServiceVersionDateA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.15.2.   UNICODE-      4   "yyyy.mm.dd".
EXPFUNC(LPWSTR) ServiceVersionDateW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.15.3.         4   "yyyy.mm.dd"    .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceVersionDate  ServiceVersionDateW
#else
 #define ServiceVersionDate  ServiceVersionDateA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.16.1.   ANSI-       4. : "Version: 4.00  Build 445 (09 Nov 2012)".
EXPFUNC(LPSTR) ServiceVersionFullA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.16.2.   UNICODE-       4. : "Version: 4.00  Build 445 (09 Nov 2012)".
EXPFUNC(LPWSTR) ServiceVersionFullW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.1.16.3.          4    . : "Version: 4.00  Build 445 (09 Nov 2012)".
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceVersionFull  ServiceVersionFullW
#else
 #define ServiceVersionFull  ServiceVersionFullA
#endif
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 2.2.     4.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 2.2.1.     4.   TRUE,     ,  - FALSE.
EXPFUNC(BOOL) ServiceMetaTraderClose();
//==============================================================================================================================================================================================================================================================
// 2.2.2.     4.   TRUE,      ,  - FALSE.
EXPFUNC(BOOL) ServiceMetaTraderHide();
//==============================================================================================================================================================================================================================================================
// 2.2.3.      4.
EXPFUNC(VOID) ServiceMetaTraderHotKeys(const INT nKeyMode, //  -.      :
                                                           // VK_SHIFT, VK_LSHIFT, VK_RSHIFT, VK_CONTROL, VK_LCONTROL, VK_RCONTROL, VK_MENU, VK_LMENU, VK_RMENU, VK_LWIN, VK_RWIN.
                                       const INT nKey);    //   .
//==============================================================================================================================================================================================================================================================
// 2.2.4.       4.
EXPFUNC(VOID) ServiceMetaTraderKeyDown(INT nKey); //  .
//==============================================================================================================================================================================================================================================================
// 2.2.5.     4.   TRUE,      ,  - FALSE.
EXPFUNC(BOOL) ServiceMetaTraderMaximize();
//==============================================================================================================================================================================================================================================================
// 2.2.6.     4.   TRUE,      ,  - FALSE.
EXPFUNC(BOOL) ServiceMetaTraderMinimize();
//==============================================================================================================================================================================================================================================================
// 2.2.7.    4.  ,   562 .
EXPFUNC(VOID) ServiceMetaTraderReboot();
//==============================================================================================================================================================================================================================================================
// 2.2.8.         4.   TRUE,      ,  - FALSE.
EXPFUNC(BOOL) ServiceMetaTraderRestore();
//==============================================================================================================================================================================================================================================================
// 2.2.9.     4.   TRUE,      ,  - FALSE.
EXPFUNC(BOOL) ServiceMetaTraderShow();
//==============================================================================================================================================================================================================================================================
// 2.2.10.      4.  ,      .
EXPFUNC(VOID) ServiceMetaTraderTitle(BOOL bTitle); //      4. FALSE -   , TRUE -   .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 2.3. , /    4.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 2.3.1.    " "  4.
EXPFUNC(VOID) ServiceHideDataWindow();
//==============================================================================================================================================================================================================================================================
// 2.3.2.    " "  4.
EXPFUNC(VOID) ServiceHideMarketWatch();
//==============================================================================================================================================================================================================================================================
// 2.3.3.    ""  4.
EXPFUNC(VOID) ServiceHideNavigator();
//==============================================================================================================================================================================================================================================================
// 2.3.4.    ""  4.
EXPFUNC(VOID) ServiceHideTerminal();
//==============================================================================================================================================================================================================================================================
// 2.3.5.    ""  4.
EXPFUNC(VOID) ServiceHideTester();
//==============================================================================================================================================================================================================================================================
// 2.3.6.   TRUE,   " "  4 ,  - FALSE.
EXPFUNC(BOOL) ServiceIsVisibleDataWindow();
//==============================================================================================================================================================================================================================================================
// 2.3.7.   TRUE,   " "  4 ,  - FALSE.
EXPFUNC(BOOL) ServiceIsVisibleMarketWatch();
//==============================================================================================================================================================================================================================================================
// 2.3.8.   TRUE,   ""  4 ,  - FALSE.
EXPFUNC(BOOL) ServiceIsVisibleNavigator();
//==============================================================================================================================================================================================================================================================
// 2.3.9.   TRUE,   ""  4 ,  - FALSE.
EXPFUNC(BOOL) ServiceIsVisibleTerminal();
//==============================================================================================================================================================================================================================================================
// 2.3.10.   TRUE,   ""  4 ,  - FALSE.
EXPFUNC(BOOL) ServiceIsVisibleTester();
//==============================================================================================================================================================================================================================================================
// 2.3.11.    " "  4.
EXPFUNC(VOID) ServiceShowDataWindow();
//==============================================================================================================================================================================================================================================================
// 2.3.12.    " "  4.
EXPFUNC(VOID) ServiceShowMarketWatch();
//==============================================================================================================================================================================================================================================================
// 2.3.13.    ""  4.
EXPFUNC(VOID) ServiceShowNavigator();
//==============================================================================================================================================================================================================================================================
// 2.3.14.    ""  4.
EXPFUNC(VOID) ServiceShowTerminal();
//==============================================================================================================================================================================================================================================================
// 2.3.15.    ""  4.
EXPFUNC(VOID) ServiceShowTester();
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 2.4. ,     4.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 2.4.1.    " ".          " ",  - NULL.
EXPFUNC(HWND) ServiceOpenGlobalVariables();
//==============================================================================================================================================================================================================================================================
// 2.4.2.    " ".          " ",  - NULL.
EXPFUNC(HWND) ServiceOpenHistoryCenter();
//==============================================================================================================================================================================================================================================================
// 2.4.3.      -     .
EXPFUNC(HWND) ServiceOpenLogin();
//==============================================================================================================================================================================================================================================================
// 2.4.4.    ""    .          "",  - NULL.
EXPFUNC(HWND) ServiceOpenOptions(const INT nTab); //    "".
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 2.5.     4.
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 2.5.1.       4:
//          LL_ENGLISH                .
//          LL_ARABIC                 .
//          LL_BULGARIAN              .
//          LL_CHINESE_SIMPLE         () .
//          LL_CHINESE_TRADITIONAL    () .
//          LL_CROATIAN               .
//          LL_CZECH                  .
//          LL_DANISH                 .
//          LL_DUTCH                  .
//          LL_ESTONIAN               .
//          LL_FARSI                 .
//          LL_FRENCH                 .
//          LL_GERMAN                 .
//          LL_GREEK                  .
//          LL_HEBREW                .
//          LL_HUNGARIAN              .
//          LL_INDONESIAN             .
//          LL_ITALIAN                .
//          LL_JAPANESE               .
//          LL_KOREAN                 .
//          LL_LATVIAN                .
//          LL_LITHUANIAN             .
//          LL_MONGOLIAN              .
//          LL_POLISH                 .
//          LL_PORTUGUESE             .
//          LL_RUSSIAN                .
//          LL_SERBIAN                .
//          LL_SLOVAK                 .
//          LL_SPANISH                .
//          LL_SWEDISH                .
//          LL_TURKISH                .
//          LL_VIETNAMESE             .
EXPFUNC(INT) ServiceGetLocalId();
//==============================================================================================================================================================================================================================================================
// 2.5.2.1.   ANSI-    4.
//            "English"                .
//            "Arabic"                 .
//            "Bulgarian"              .
//            "Chinese (Simple)"       () .
//            "Chinese (Traditional)"  () .
//            "Croatian"               .
//            "Czech"                  .
//            "Danish"                 .
//            "Dutch"                  .
//            "Estonian"               .
//            "Farsi"                 .
//            "French"                 .
//            "German"                 .
//            "Greek"                  .
//            "Hebrew"                .
//            "Hungarian"              .
//            "Indonesian"             .
//            "Italian"                .
//            "Japanese"               .
//            "Korean"                 .
//            "Latvian"                .
//            "Lithuanian"             .
//            "Mongolian"              .
//            "Polish"                 .
//            "Portuguese (Brazil)"    .
//            "Russian"                .
//            "Serbian"                .
//            "Slovak"                 .
//            "Spanish"                .
//            "Swedish"                .
//            "Turkish"                .
//            "Vietnamese"             .
EXPFUNC(LPSTR) ServiceGetLocalStrA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.5.2.2.   UNICODE-    4.
//            "English"                .
//            "Arabic"                 .
//            "Bulgarian"              .
//            "Chinese (Simple)"       () .
//            "Chinese (Traditional)"  () .
//            "Croatian"               .
//            "Czech"                  .
//            "Danish"                 .
//            "Dutch"                  .
//            "Estonian"               .
//            "Farsi"                 .
//            "French"                 .
//            "German"                 .
//            "Greek"                  .
//            "Hebrew"                .
//            "Hungarian"              .
//            "Indonesian"             .
//            "Italian"                .
//            "Japanese"               .
//            "Korean"                 .
//            "Latvian"                .
//            "Lithuanian"             .
//            "Mongolian"              .
//            "Polish"                 .
//            "Portuguese (Brazil)"    .
//            "Russian"                .
//            "Serbian"                .
//            "Slovak"                 .
//            "Spanish"                .
//            "Swedish"                .
//            "Turkish"                .
//            "Vietnamese"             .
EXPFUNC(LPWSTR) ServiceGetLocalStrW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.5.2.3.       4   .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceGetLocalStr  ServiceGetLocalStrW
#else
 #define ServiceGetLocalStr  ServiceGetLocalStrA
#endif
//==============================================================================================================================================================================================================================================================
// 2.5.3.      4.
EXPFUNC(VOID) ServiceSetLocal(const INT  nCodeLocalization, //  .     :
                                                            //   LL_ENGLISH                .
                                                            //   LL_ARABIC                 .
                                                            //   LL_BULGARIAN              .
                                                            //   LL_CHINESE_SIMPLE         () .
                                                            //   LL_CHINESE_TRADITIONAL    () .
                                                            //   LL_CROATIAN               .
                                                            //   LL_CZECH                  .
                                                            //   LL_DANISH                 .
                                                            //   LL_DUTCH                  .
                                                            //   LL_ESTONIAN               .
                                                            //   LL_FARSI                 .
                                                            //   LL_FRENCH                 .
                                                            //   LL_GERMAN                 .
                                                            //   LL_GREEK                  .
                                                            //   LL_HEBREW                .
                                                            //   LL_HUNGARIAN              .
                                                            //   LL_INDONESIAN             .
                                                            //   LL_ITALIAN                .
                                                            //   LL_JAPANESE               .
                                                            //   LL_KOREAN                 .
                                                            //   LL_LATVIAN                .
                                                            //   LL_LITHUANIAN             .
                                                            //   LL_POLISH                 .
                                                            //   LL_PORTUGUESE             .
                                                            //   LL_RUSSIAN                .
                                                            //   LL_SERBIAN                .
                                                            //   LL_SLOVAK                 .
                                                            //   LL_SPANISH                .
                                                            //   LL_SWEDISH                .
                                                            //   LL_TURKISH                .
                                                            //   LL_VIETNAMESE             .
                              const BOOL bRestart);         //   ,   529 .   : TRUE -     , FALSE -      .
//
// 3.      .
//
// 3.1.    .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 3.1.1.  /   .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceAutoScroll(const HWND hwndChart); //    ,    .
//==============================================================================================================================================================================================================================================================
// 3.1.2.  /   .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceShift(const HWND hwndChart); //    ,   / .
//==============================================================================================================================================================================================================================================================
// 3.1.3.  /     .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceShowGrid(const HWND hwndChart); //    ,   /  .
//==============================================================================================================================================================================================================================================================
// 3.1.4.  /     .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceShowVolume(const HWND hwndChart); //    ,   /  .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 3.2.    .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 3.2.1.       .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetAutoScroll(const HWND hwndChart); //    ,     .
//==============================================================================================================================================================================================================================================================
// 3.2.2.    " "   .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetScaleFix(const HWND hwndChart); //    ,     " ".
//==============================================================================================================================================================================================================================================================
// 3.2.3.    "  1:1"   .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetScaleFix1To1(const HWND hwndChart); //    ,     "  1:1".
//==============================================================================================================================================================================================================================================================
// 3.2.4.    " "   .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetForeground(const HWND hwndChart); //    ,     " ".
//==============================================================================================================================================================================================================================================================
// 3.2.5.      .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetOffline(const HWND hwndChart); //    ,     .
//==============================================================================================================================================================================================================================================================
// 3.2.6.      .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetShift(const HWND hwndChart); //    ,     .
//==============================================================================================================================================================================================================================================================
// 3.2.7.      ASK   .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetShowAsk(const HWND hwndChart); //    ,       ASK.
//==============================================================================================================================================================================================================================================================
// 3.2.8.        .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetShowGrid(const HWND hwndChart); //    ,      .
//==============================================================================================================================================================================================================================================================
// 3.2.9.         .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetShowObjectDescript(const HWND hwndChart); //    ,       .
//==============================================================================================================================================================================================================================================================
// 3.2.10.      OHLC   .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetShowOHLC(const HWND hwndChart); //    ,       OHLC.
//==============================================================================================================================================================================================================================================================
// 3.2.11.         .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetShowPeriodSeparators(const HWND hwndChart); //    ,       .
//==============================================================================================================================================================================================================================================================
// 3.2.12.        .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceGetShowVolume(const HWND hwndChart); //    ,      .
//==============================================================================================================================================================================================================================================================
// 3.2.13.         .
//             : VS_BARS     ;
//                                           VS_CANDLES   ;
//                                           VS_LINE     .
EXPFUNC(INT) ServiceGetViewChart(const HWND hwndChart); //    ,       .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 3.3.    .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 3.3.1.       .      .
EXPFUNC(BOOL) ServiceSetAutoScroll(const HWND hwndChart,  //    ,     .
                                   const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.2.      .      .
EXPFUNC(BOOL) ServiceSetOffline(const HWND hwndChart,  //    ,     .
                                const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.3.      .
EXPFUNC(VOID) ServiceSetScale(const HWND   hwndChart, //    ,     " ".
                              const double dMaximum,  //  .
                              const double dMinimum); //  .
//==============================================================================================================================================================================================================================================================
// 3.3.4.    " "   .      .
EXPFUNC(BOOL) ServiceSetScaleFix(const HWND hwndChart,  //    ,     " ".
                                 const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.5.    "  1:1"   .      .
EXPFUNC(BOOL) ServiceSetScaleFix1To1(const HWND hwndChart,  //    ,     "  1:1".
                                     const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.6.    " "   .      .
EXPFUNC(BOOL) ServiceSetForeground(const HWND hwndChart,  //    ,     " ".
                                   const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.7.      .      .
EXPFUNC(BOOL) ServiceSetShift(const HWND hwndChart,  //    ,     .
                              const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.8.      ASK   .      .
EXPFUNC(BOOL) ServiceSetShowAsk(const HWND hwndChart,  //    ,       ASK.
                                const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.9.        .      .
EXPFUNC(BOOL) ServiceSetShowGrid(const HWND hwndChart,  //    ,      .
                                 const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.10.         .      .
EXPFUNC(BOOL) ServiceSetShowObjectDescript(const HWND hwndChart,  //    ,       .
                                           const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.11.      OHLC   .      .
EXPFUNC(BOOL) ServiceSetShowOHLC(const HWND hwndChart,  //    ,       OHLC.
                                 const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.12.         .      .
EXPFUNC(BOOL) ServiceSetShowPeriodSeparators(const HWND hwndChart,  //    ,       .
                                             const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.13.        .      .
EXPFUNC(BOOL) ServiceSetShowVolume(const HWND hwndChart,  //    ,      .
                                   const BOOL bProperty); //  : FALSE -  , TRUE -  .
//==============================================================================================================================================================================================================================================================
// 3.3.14.        .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceSetViewChart(const HWND hwndChart, //    ,      .
                                  const INT  nView);    //     : VS_BARS     ;
                                                        //                                   VS_CANDLES   ;
                                                        //                                   VS_LINE     .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 3.4.    .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 3.4.1.      .       .
EXPFUNC(HWND) ServiceOpenPropertiesChart(const HWND hwndChart,    //   ,     .
                                         const INT  nTabControl); //   : 0 - "", 1 - "".
//==============================================================================================================================================================================================================================================================
// 3.4.2.            .
EXPFUNC(VOID) ServicePropertiesChartCheckBox(const HWND                                      hwndChart,     //   ,     .
                                             const BOOL                                      bSet,          //     :
                                                                                                            //   TRUE  -   ,   "dwControlId"  ,    "bProperty";
                                                                                                            //   FALSE -    ,      .
                                                   Utils::Control::PROPERTIES_NUMERIC<BOOL>* apbProperties, //          .   .
                                                                                                            //  :
                                                                                                            //   DWORD dwControlId;    .
                                                                                                            //   BOOL  bProperty;      .
                                                                                                            //   DWORD dwDecimals;         .     .
                                                                                                            //   "bProperty"     ,    "dwControlId".
                                             const INT                                       nCount);       //    .    "apbProperties[]".
//
// 4.      .
//
// 4.1.       .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.1.1.   TRUE,       ,  - FALSE.
EXPFUNC(BOOL) ServiceChartCheckPressKey(const HWND hwndChart, //    ,    .
                                        const INT  nKey);     //   .
//==============================================================================================================================================================================================================================================================
// 4.1.2.       .
EXPFUNC(VOID) ServiceChartHotKeys(const HWND hwndChart, //   ,     .
                                  const INT  nKeyMode,  //  -.      :
                                                        // VK_SHIFT, VK_LSHIFT, VK_RSHIFT, VK_CONTROL, VK_LCONTROL, VK_RCONTROL, VK_MENU, VK_LMENU, VK_RMENU, VK_LWIN, VK_RWIN.
                                  const INT  nKey);     //   .
//==============================================================================================================================================================================================================================================================
// 4.1.3.       .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceChartKeyDown(const HWND hwndChart, //   ,    .
                                  const INT  nKey);     //  .
//==============================================================================================================================================================================================================================================================
// 4.1.4.       .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceChartKeyUp(const HWND hwndChart, //   ,    .
                                const INT  nKey);     //  .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.2.      .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.2.1.     .
EXPFUNC(VOID) ServiceCloseAllCharts();
//==============================================================================================================================================================================================================================================================
// 4.2.2.     .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceCloseChart(const HWND hwndChart); //     .
//==============================================================================================================================================================================================================================================================
// 4.2.3.       .
EXPFUNC(HWND) ServiceGetHandleActiveChart();
//==============================================================================================================================================================================================================================================================
// 4.2.4.1.             .   ,  ,        .
//             ANSI-.
EXPFUNC(HWND) ServiceGetHandleChartA(LPCSTR    szSymbol, //  .
                                     const INT nPeriod); //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.2.4.2.             .   ,  ,        .
//             UNICODE-.
EXPFUNC(HWND) ServiceGetHandleChartW(LPCWSTR   szSymbol, //  .
                                     const INT nPeriod); //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.2.4.3.             .   ,  ,        .
//               .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceGetHandleChart  ServiceGetHandleChartW
#else
 #define ServiceGetHandleChart  ServiceGetHandleChartA
#endif
//==============================================================================================================================================================================================================================================================
// 4.2.5.                .
EXPFUNC(INT) ServiceGetHandlesAllCharts(      HWND* ahwndCharts, //    .         .
                                        const INT   nSize);      //   .
//==============================================================================================================================================================================================================================================================
// 4.2.6.1.                        .
//             ANSI-.
EXPFUNC(HWND) ServiceGetHandlesEqualChartsA(LPCSTR       szSymbol,    //  .
                                            const  INT   nPeriod,     //    .
                                                   HWND* ahwndCharts, //    .
                                            const  INT   nSize);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.2.6.2.                        .
//             UNICODE-.
EXPFUNC(HWND) ServiceGetHandlesEqualChartsW(LPCWSTR      szSymbol,    //  .
                                            const  INT   nPeriod,     //    .
                                                   HWND* ahwndCharts, //    .
                                            const  INT   nSize);      //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.2.6.3.                        .
//               .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceGetHandlesEqualCharts  ServiceGetHandlesEqualChartsW
#else
 #define ServiceGetHandlesEqualCharts  ServiceGetHandlesEqualChartsA
#endif
//==============================================================================================================================================================================================================================================================
// 4.2.7.               .
EXPFUNC(INT) ServiceGetHandlesOfflineCharts(      HWND* ahwndCharts, //    .
                                            const INT   nSize);      //   .
//==============================================================================================================================================================================================================================================================
// 4.2.8.          online-    .
EXPFUNC(INT) ServiceGetHandlesOnlineCharts(      HWND* ahwndCharts, //    .
                                           const INT   nSize);      //   .
//==============================================================================================================================================================================================================================================================
// 4.2.9.        .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceIsChart(const HWND hwndChart); //     .
//==============================================================================================================================================================================================================================================================
// 4.2.10.          .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceIsChartActive(const HWND hwndChart); //     .
//==============================================================================================================================================================================================================================================================
// 4.2.11.   TRUE,   ,  - FALSE.
EXPFUNC(BOOL) ServiceIsChartOffline(const HWND hwndChart); //     .
//==============================================================================================================================================================================================================================================================
// 4.2.12.      .
EXPFUNC(INT) ServiceNumberCharts();
//==============================================================================================================================================================================================================================================================
// 4.2.13.     .
EXPFUNC(VOID) ServiceSetActiveChart(HWND hwndChart); //     .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.3.     .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.3.1.      .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceDeselectObjects(const HWND hwndChart); //    ,       .
//==============================================================================================================================================================================================================================================================
// 4.3.2.         .
EXPFUNC(VOID) ServiceSetBar(const HWND       hwndChart, //    ,   .
                            const __time32_t tBar);     //      .
//==============================================================================================================================================================================================================================================================
// 4.3.3.       .
EXPFUNC(VOID) ServiceStepByStep(const HWND hwndChart); //    ,    .
//==============================================================================================================================================================================================================================================================
// 4.3.4.      .
EXPFUNC(BOOL) ServiceZoom(const HWND hwndChart, //    ,     .
                          const BOOL bZoom);    //    : TRUE  -     ;
                                                //                                       FALSE -     .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.4.    .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.4.1.         .
EXPFUNC(VOID) ServiceDeleteTemplate(const INT nTemplate); //     .      .    64.
//==============================================================================================================================================================================================================================================================
// 4.4.2.1.        .    ANSI-.
EXPFUNC(VOID) ServiceSaveTemplateA(const HWND hwndChart,       //    ,    .
                                   LPCSTR     szNameTemplate); //  ,    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.4.2.2.        .    UNICODE-.
EXPFUNC(VOID) ServiceSaveTemplateW(const HWND hwndChart,       //    ,    .
                                   LPCWSTR    szNameTemplate); //  ,    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.4.2.3.        .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceSaveTemplate  ServiceSaveTemplateW
#else
 #define ServiceSaveTemplate  ServiceSaveTemplateA
#endif
//==============================================================================================================================================================================================================================================================
// 4.4.3.1.             .    ANSI-.
EXPFUNC(VOID) ServiceSetTemplateByNameA(const HWND hwndChart,      //    ,   .
                                        LPCSTR     szNameTemplate, //     .
                                        const BOOL bWaitEnd);      //     : TRUE  -         ( );
                                                                   //                                             FALSE -      ,     ( ).
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.4.3.2.             .    UNICODE-.
EXPFUNC(VOID) ServiceSetTemplateByNameW(const HWND hwndChart,      //    ,   .
                                        LPCWSTR    szNameTemplate, //     .
                                        const BOOL bWaitEnd);      //     : TRUE  -         ( );
                                                                   //                                             FALSE -      ,     ( ).
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.4.3.3.             .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceSetTemplateByName  ServiceSetTemplateByNameW
#else
 #define ServiceSetTemplateByName  ServiceSetTemplateByNameA
#endif
//==============================================================================================================================================================================================================================================================
// 4.4.4.             .
EXPFUNC(VOID) ServiceSetTemplateByIndex(const HWND hwndChart, //    ,   .
                                        const INT  nTemplate, //     .      .    64.
                                        const BOOL bWaitEnd); //     : TRUE  -         ( );
                                                              //                                             FALSE -      ,     ( ).
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.5.       .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.5.1.1.          .    ANSI-.
EXPFUNC(VOID) ServiceSetTimeframeByNameA(const HWND hwndChart, //    ,    .
                                         LPCSTR     szName);   //   : "M1"    1 ;
                                                               //                          "M5"    5 ;
                                                               //                          "M15"  15 ;
                                                               //                          "M30"  30 ;
                                                               //                          "H1"    1 ;
                                                               //                          "H4"    4 ;
                                                               //                          "D1"    1 ;
                                                               //                          "W1"    1 ;
                                                               //                          "MN1"   1 .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.5.1.2.          .    UNICODE-.
EXPFUNC(VOID) ServiceSetTimeframeByNameW(const HWND hwndChart, //    ,    .
                                         LPCWSTR    szName);   //   : "M1"    1 ;
                                                               //                          "M5"    5 ;
                                                               //                          "M15"  15 ;
                                                               //                          "M30"  30 ;
                                                               //                          "H1"    1 ;
                                                               //                          "H4"    4 ;
                                                               //                          "D1"    1 ;
                                                               //                          "W1"    1 ;
                                                               //                          "MN1"   1 .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.5.1.3.          .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceSetTimeframeByName  ServiceSetTimeframeByNameW
#else
 #define ServiceSetTimeframeByName  ServiceSetTimeframeByNameA
#endif
//==============================================================================================================================================================================================================================================================
// 4.5.2.          .
EXPFUNC(VOID) ServiceSetTimeframeByIndex(const HWND hwndChart,   //    ,    .
                                         const INT  nTimeFrame); //     0  8.
//==============================================================================================================================================================================================================================================================
// 4.5.3.          .
EXPFUNC(VOID) ServiceSetTimeframeByPeriod(const HWND hwndChart, //    ,    .
                                          const INT  nPeriod);  //   : PERIOD_M1       1  1 ;
                                                                //                             PERIOD_M5       5  5 ;
                                                                //                             PERIOD_M15     15  15 ;
                                                                //                             PERIOD_M30     30  30 ;
                                                                //                             PERIOD_H1      60  1 ;
                                                                //                             PERIOD_H4     240  4 ;
                                                                //                             PERIOD_D1    1440  1 ;
                                                                //                             PERIOD_W1   10080  1 ;
                                                                //                             PERIOD_MN1  43200  1 .
//==============================================================================================================================================================================================================================================================
// 4.5.4.1.    /      .    ANSI-.
EXPFUNC(VOID) ServiceSetToolChartNamePeriodA(const HWND hwndChart,     //    ,    .
                                             LPCSTR     szSymbol,      //     " ".    ,   .
                                             LPCSTR     szNamePeriod); //   .    ,   .
                                                                       //  : "M1"    1 ;
                                                                       //                     "M5"    5 ;
                                                                       //                     "M15"  15 ;
                                                                       //                     "M30"  30 ;
                                                                       //                     "H1"    1 ;
                                                                       //                     "H4"    4 ;
                                                                       //                     "D1"    1 ;
                                                                       //                     "W1"    1 ;
                                                                       //                     "MN1"   1 .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.5.4.2.    /      .    UNICODE-.
EXPFUNC(VOID) ServiceSetToolChartNamePeriodW(const HWND hwndChart,     //    ,    .
                                             LPCWSTR    szSymbol,      //     " ".    ,   .
                                             LPCWSTR    szNamePeriod); //   .    ,   .
                                                                       //  : "M1"    1 ;
                                                                       //                     "M5"    5 ;
                                                                       //                     "M15"  15 ;
                                                                       //                     "M30"  30 ;
                                                                       //                     "H1"    1 ;
                                                                       //                     "H4"    4 ;
                                                                       //                     "D1"    1 ;
                                                                       //                     "W1"    1 ;
                                                                       //                     "MN1"   1 .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.5.1.3.    /      .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceSetToolChartNamePeriod  ServiceSetToolChartNamePeriodW
#else
 #define ServiceSetToolChartNamePeriod  ServiceSetToolChartNamePeriodA
#endif
//==============================================================================================================================================================================================================================================================
// 4.5.5.1.    /      .    ANSI-.
EXPFUNC(VOID) ServiceSetToolChartIndexPeriodA(const HWND hwndChart,   //    ,    .
                                              LPCSTR     szSymbol,    //     " ".    ,   .
                                              const INT  nTimeFrame); //     0  8.    ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.5.5.2.    /      .    UNICODE-.
EXPFUNC(VOID) ServiceSetToolChartIndexPeriodW(const HWND hwndChart,   //    ,    .
                                              LPCWSTR    szSymbol,    //     " ".    ,   .
                                              const INT  nTimeFrame); //     0  8.    ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.5.5.3.    /      .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceSetToolChartIndexPeriod  ServiceSetToolChartIndexPeriodW
#else
 #define ServiceSetToolChartIndexPeriod  ServiceSetToolChartIndexPeriodA
#endif
//==============================================================================================================================================================================================================================================================
// 4.5.6.1.    /      .    ANSI-.
EXPFUNC(VOID) ServiceSetToolChartPeriodA(const HWND hwndChart, //    ,    .
                                         LPCSTR     szSymbol,  //     " ".    ,   .
                                         const INT  nPeriod);  //   .    ,   .
                                                               //  : PERIOD_M1       1   1 ;
                                                               //                     PERIOD_M5       5   5 ;
                                                               //                     PERIOD_M15     15  15 ;
                                                               //                     PERIOD_M30     30  30 ;
                                                               //                     PERIOD_H1      60   1 ;
                                                               //                     PERIOD_H4     240   4 ;
                                                               //                     PERIOD_D1    1440   1 ;
                                                               //                     PERIOD_W1   10080   1 ;
                                                               //                     PERIOD_MN1  43200   1 .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.5.6.2.    /      .    UNICODE-.
EXPFUNC(VOID) ServiceSetToolChartPeriodW(const HWND hwndChart, //    ,    .
                                         LPCWSTR    szSymbol,  //     " ".    ,   .
                                         const INT  nPeriod);  //   .    ,   .
                                                               //  : PERIOD_M1       1   1 ;
                                                               //                     PERIOD_M5       5   5 ;
                                                               //                     PERIOD_M15     15  15 ;
                                                               //                     PERIOD_M30     30  30 ;
                                                               //                     PERIOD_H1      60   1 ;
                                                               //                     PERIOD_H4     240   4 ;
                                                               //                     PERIOD_D1    1440   1 ;
                                                               //                     PERIOD_W1   10080   1 ;
                                                               //                     PERIOD_MN1  43200   1 .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.5.6.3.    /      .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceSetToolChartPeriod  ServiceSetToolChartPeriodW
#else
 #define ServiceSetToolChartPeriod  ServiceSetToolChartPeriodA
#endif
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.6.       .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.6.1.           .
EXPFUNC(VOID) ServiceCmdClose(const HWND hwndChart); //    ,     .
//==============================================================================================================================================================================================================================================================
// 4.6.2.        .
EXPFUNC(VOID) ServiceCmdClear(const HWND hwndChart); //    ,      .
//==============================================================================================================================================================================================================================================================
// 4.6.3.       ,    ,      ,     .       .
EXPFUNC(HWND) ServiceCmdCreat(const HWND hwndChart); //    ,     .
//==============================================================================================================================================================================================================================================================
// 4.6.4.         .    ,   TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceCmdHas(const HWND hwndChart); //    ,      .
//==============================================================================================================================================================================================================================================================
// 4.6.5.         .    ,   TRUE.          FALSE.
EXPFUNC(BOOL) ServiceCmdIsVisible(const HWND hwndChart); //    ,      .
//==============================================================================================================================================================================================================================================================
// 4.6.6.         .       .
EXPFUNC(HWND) ServiceCmdOpen(const HWND hwndChart); //    ,     .
//==============================================================================================================================================================================================================================================================
// 4.6.7.1.        .    ANSI-.
EXPFUNC(LPSTR) ServiceCmdReadA(const HWND hwndChart); //    ,       .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.6.7.2.        .    UNICODE-.
EXPFUNC(LPWSTR) ServiceCmdReadW(const HWND hwndChart); //    ,       .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.6.7.3.        .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceCmdRead  ServiceCmdReadW
#else
 #define ServiceCmdRead  ServiceCmdReadA
#endif
//==============================================================================================================================================================================================================================================================
// 4.6.8.1.         .    ANSI-.
EXPFUNC(VOID) ServiceCmdWriteA(const HWND hwndChart, //    ,     .
                               LPCSTR     szText);   //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.6.8.2.         .    UNICODE-.
EXPFUNC(VOID) ServiceCmdWriteW(const HWND hwndChart, //    ,     .
                               LPCWSTR    szText);   //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.6.8.3.         .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceCmdWrite  ServiceCmdWriteW
#else
 #define ServiceCmdWrite  ServiceCmdWriteA
#endif
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.7.     .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.7.1.        .    ,      .
//           "ServiceStopRefreshChart()"  "ServiceStopRefreshAllCharts()"   .
EXPFUNC(VOID) ServiceRefreshAllCharts(const INT nPeriodMilliSec); //     .
//==============================================================================================================================================================================================================================================================
// 4.7.2.      .          .
EXPFUNC(VOID) ServiceRefreshAllOnceCharts();
//==============================================================================================================================================================================================================================================================
// 4.7.3.        .    ,       .
//           "ServiceStopRefreshChart()"  "ServiceStopRefreshAllCharts()"   .
EXPFUNC(VOID) ServiceStartRefreshChart(const HWND hwndChart,        //    .
                                       const INT  nPeriodMilliSec); //     .
//==============================================================================================================================================================================================================================================================
// 4.7.4.        .    ,      .
//           "ServiceStopRefreshChart()"  "ServiceStopRefreshAllCharts()"   .
EXPFUNC(VOID) ServiceRefreshOfflineCharts(const INT nPeriodMilliSec); //     .
//==============================================================================================================================================================================================================================================================
// 4.7.5.    online-   .    ,      .
//           "ServiceStopRefreshChart()"  "ServiceStopRefreshAllCharts()"   .
EXPFUNC(VOID) ServiceRefreshOnlineCharts(const INT nPeriodMilliSec); //     .
//==============================================================================================================================================================================================================================================================
// 4.7.6.     .
EXPFUNC(VOID) ServiceStopRefreshChart(const HWND hwndChart); //   ,    .
//==============================================================================================================================================================================================================================================================
// 4.7.7.        bTerminate = FALSE,     .
EXPFUNC(VOID) ServiceStopRefreshAllCharts(const BOOL bTerminate); //      . FALSE -   , TRUE -   .
//==============================================================================================================================================================================================================================================================
// 4.7.8.        .
EXPFUNC(VOID) ServiceTickExpert(const HWND hwndChart); //    ,     .
//==============================================================================================================================================================================================================================================================
// 4.7.9.        .
EXPFUNC(VOID) ServiceTickIndicators(const HWND hwndChart); //    ,     .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.8.    .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 4.8.1.         .
EXPFUNC(VOID) ServiceDeleteProfile(const INT nProfile); //     .      .    64.
//==============================================================================================================================================================================================================================================================
// 4.8.2.1.   ANSI-  .
EXPFUNC(LPSTR) ServiceGetCurrentProfileA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.8.2.2.   UNICODE-  .
EXPFUNC(LPWSTR) ServiceGetCurrentProfileW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.8.2.3.        .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceGetCurrentProfile  ServiceGetCurrentProfileW
#else
 #define ServiceGetCurrentProfile  ServiceGetCurrentProfileA
#endif
//==============================================================================================================================================================================================================================================================
// 4.8.3.     " ".          " ",  - NULL.
EXPFUNC(HWND) ServiceOpenSaveProfile();
//==============================================================================================================================================================================================================================================================
// 4.8.4.1.      .    ANSI-.
EXPFUNC(VOID) ServiceSaveProfileA(LPCSTR szNameProfile); //  ,    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.8.4.2.      .    UNICODE-.
EXPFUNC(VOID) ServiceSaveProfileW(LPCWSTR szNameProfile); //  ,    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.8.4.3.      .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceSaveProfile  ServiceSaveProfileW
#else
 #define ServiceSaveProfile  ServiceSaveProfileA
#endif
//==============================================================================================================================================================================================================================================================
// 4.8.5.         .
EXPFUNC(VOID) ServiceSetProfileByIndex(const INT  nProfile,  //     .      .    64.
                                       const BOOL bWaitEnd); //     : TRUE  -         ( );
                                                             //                                             FALSE -      ,     ( ).
//==============================================================================================================================================================================================================================================================
// 4.8.6.         .
EXPFUNC(VOID) ServiceSetProfileNext();
//==============================================================================================================================================================================================================================================================
// 4.8.7.         .
EXPFUNC(VOID) ServiceSetProfilePrevious();
//
// 5.      "".
//
// 5.1.   .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.1.1.1.   ANSI-       .           .
EXPFUNC(LPSTR) ServiceServerByIndexA(const INT nIndex); //   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.1.1.2.   UNICODE-       .           .
EXPFUNC(LPWSTR) ServiceServerByIndexW(const INT nIndex); //   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.1.1.3.             .           .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceServerByIndex  ServiceServerByIndexW
#else
 #define ServiceServerByIndex  ServiceServerByIndexA
#endif
//==============================================================================================================================================================================================================================================================
// 5.1.2.       .
EXPFUNC(INT) ServiceServers();
//==============================================================================================================================================================================================================================================================
// 5.1.3.1.   TRUE,        ,  - FALSE.    ANSI-.
EXPFUNC(BOOL) ServiceIsServerA(LPCSTR szNameServer); //  .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.1.3.2.   TRUE,        ,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) ServiceIsServerW(LPCWSTR szNameServer); //  .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.1.3.3.   TRUE,        ,  - FALSE.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceIsServer  ServiceIsServerW
#else
 #define ServiceIsServer  ServiceIsServerA
#endif
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.2.   .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.2.1.         .    ,    TRUE,    - FALSE.
EXPFUNC(BOOL) ServiceAccountIsDemo(const INT nIndex); //   ,   .
//==============================================================================================================================================================================================================================================================
// 5.2.2.1.   ANSI-       .           .
EXPFUNC(LPSTR) ServiceAccountNameByIndexA(const INT nIndex); //   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.2.2.   UNICODE-       .           .
EXPFUNC(LPWSTR) ServiceAccountNameByIndexW(const INT nIndex); //   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.2.3.          .           .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceAccountNameByIndex  ServiceAccountNameByIndexW
#else
 #define ServiceAccountNameByIndex  ServiceAccountNameByIndexA
#endif
//==============================================================================================================================================================================================================================================================
// 5.2.3.         .          .
EXPFUNC(INT) ServiceAccountNumByIndex(const INT nIndex); //   ,   .
//==============================================================================================================================================================================================================================================================
// 5.2.4.1.   ANSI-       .           .    567    .
EXPFUNC(LPSTR) ServiceAccountServerByIndexA(const INT nIndex); //   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.4.2.   UNICODE-       .           .    567    .
EXPFUNC(LPWSTR) ServiceAccountServerByIndexW(const INT nIndex); //   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.4.3.              .           .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceAccountServerByIndex  ServiceAccountServerByIndexW
#else
 #define ServiceAccountServerByIndex  ServiceAccountServerByIndexA
#endif
//==============================================================================================================================================================================================================================================================
// 5.2.5.      .
EXPFUNC(INT) ServiceAccounts();
//==============================================================================================================================================================================================================================================================
// 5.2.6.1.   TRUE,               ,  - FALSE.    ANSI-.
EXPFUNC(BOOL) ServiceIsAccountFullA(LPCSTR    szNameServer,  //  .    567   .
                                    LPCSTR    szNameAccount, //   .
                                    const INT nNumber);      //  .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.6.2.   TRUE,               ,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) ServiceIsAccountFullW(LPCWSTR   szNameServer,  //  .    567   .
                                    LPCWSTR   szNameAccount, //   .
                                    const INT nNumber);      //  .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.6.3.   TRUE,             ,  - FALSE.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceIsAccountFull  ServiceIsAccountFullW
#else
 #define ServiceIsAccountFull  ServiceIsAccountFullA
#endif
//==============================================================================================================================================================================================================================================================
// 5.2.7.1.   TRUE,         ,  - FALSE.    ANSI-.
EXPFUNC(BOOL) ServiceIsAccountNameA(LPCSTR szName); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.7.2.   TRUE,         ,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) ServiceIsAccountNameW(LPCWSTR szName); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.7.3.   TRUE,         ,  - FALSE.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceIsAccountName  ServiceIsAccountNameW
#else
 #define ServiceIsAccountName  ServiceIsAccountNameA
#endif
//==============================================================================================================================================================================================================================================================
// 5.2.8.   TRUE,        ,  - FALSE.
EXPFUNC(BOOL) ServiceIsAccountNumber(const INT nNumber); //  .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.3.    .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.3.1.1.   ANSI-        .           .
EXPFUNC(LPSTR) ServiceStdIndicatorByIndexA(const INT nIndex); //    ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.3.1.2.   UNICODE-        .           .
EXPFUNC(LPWSTR) ServiceStdIndicatorByIndexW(const INT nIndex); //    ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.3.1.3.           .           .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceStdIndicatorByIndex  ServiceStdIndicatorByIndexW
#else
 #define ServiceStdIndicatorByIndex  ServiceStdIndicatorByIndexA
#endif
//==============================================================================================================================================================================================================================================================
// 5.3.2.       .
EXPFUNC(INT) ServiceStdIndicators();
//==============================================================================================================================================================================================================================================================
// 5.3.3.1.   TRUE,         ,  - FALSE.    ANSI-.
EXPFUNC(BOOL) ServiceIsStdIndicatorA(LPCSTR szNameIndicator); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.3.3.2.   TRUE,         ,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) ServiceIsStdIndicatorW(LPCWSTR szNameIndicator); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.3.3.3.   TRUE,         ,  - FALSE.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceIsStdIndicator  ServiceIsStdIndicatorW
#else
 #define ServiceIsStdIndicator  ServiceIsStdIndicatorA
#endif
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.4.   .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.4.1.1.   ANSI-       .           .
EXPFUNC(LPSTR) ServiceExpertByIndexA(const INT nIndex); //   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.4.1.2.   UNICODE-       .           .
EXPFUNC(LPWSTR) ServiceExpertByIndexW(const INT nIndex); //   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.4.1.3.          .           .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceExpertByIndex  ServiceExpertByIndexW
#else
 #define ServiceExpertByIndex  ServiceExpertByIndexA
#endif
//==============================================================================================================================================================================================================================================================
// 5.4.2.      .
EXPFUNC(INT) ServiceExperts();
//==============================================================================================================================================================================================================================================================
// 5.4.3.1.   TRUE,        ,  - FALSE.    ANSI-.
EXPFUNC(BOOL) ServiceIsExpertA(LPCSTR szNameExpert); //  .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.4.3.2.   TRUE,        ,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) ServiceIsExpertW(LPCWSTR szNameExpert); //  .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.4.3.3.   TRUE,        ,  - FALSE.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceIsExpert  ServiceIsExpertW
#else
 #define ServiceIsExpert  ServiceIsExpertA
#endif
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.5.    .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.5.1.1.   ANSI-        .           .
EXPFUNC(LPSTR) ServiceCustomIndicatorByIndexA(const INT nIndex); //    ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.5.1.2.   UNICODE-        .           .
EXPFUNC(LPWSTR) ServiceCustomIndicatorByIndexW(const INT nIndex); //    ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.5.1.3.           .           .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceCustomIndicatorByIndex  ServiceCustomIndicatorByIndexW
#else
 #define ServiceCustomIndicatorByIndex  ServiceCustomIndicatorByIndexA
#endif
//==============================================================================================================================================================================================================================================================
// 5.5.2.       .
EXPFUNC(INT) ServiceCustomIndicators();
//==============================================================================================================================================================================================================================================================
// 5.5.3.1.   TRUE,         ,  - FALSE.    ANSI-.
EXPFUNC(BOOL) ServiceIsCustomIndicatorA(LPCSTR szNameIndicator); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.5.3.2.   TRUE,         ,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) ServiceIsCustomIndicatorW(LPCWSTR szNameIndicator); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.5.3.3.   TRUE,         ,  - FALSE.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceIsCustomIndicator  ServiceIsCustomIndicatorW
#else
 #define ServiceIsCustomIndicator  ServiceIsCustomIndicatorA
#endif
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.6.   .
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 5.6.1.1.   ANSI-       .           .
EXPFUNC(LPSTR) ServiceScriptByIndexA(const INT nIndex); //   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.6.1.2.   UNICODE-       .           .
EXPFUNC(LPWSTR) ServiceScriptByIndexW(const INT nIndex); //   ,   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.6.1.3.            .           .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceScriptByIndex  ServiceScriptByIndexW
#else
 #define ServiceScriptByIndex  ServiceScriptByIndexA
#endif
//==============================================================================================================================================================================================================================================================
// 5.6.2.      .
EXPFUNC(INT) ServiceScripts();
//==============================================================================================================================================================================================================================================================
// 5.6.3.1.   TRUE,        ,  - FALSE.    ANSI-.
EXPFUNC(BOOL) ServiceIsScriptA(LPCSTR szNameScript); //  .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.6.3.2.   TRUE,        ,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) ServiceIsScriptW(LPCWSTR szNameScript); //  .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.6.3.3.   TRUE,        ,  - FALSE.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceIsScript  ServiceIsScriptW
#else
 #define ServiceIsScript  ServiceIsScriptA
#endif
//
// 6.      " ".
//
// 6.1.1.      ANSI-     " "    .      -1.  .
EXPFUNC(INT) ServiceGetAllSymbolsA(      LPSTR* paszSymbols, //       ANSI-       " ".
                                   const INT    nSize0,      //      (   ).
                                   const INT    nSize1);     //     .     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.1.2.      UNICODE-     " "    .      -1.  .
EXPFUNC(INT) ServiceGetAllSymbolsW(      LPWSTR* paszSymbols, //       UNICODE-       " ".
                                   const INT     nSize0,      //      (   ).
                                   const INT     nSize1);     //     .     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.1.3.              " "    .      -1.  .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceGetAllSymbols  ServiceGetAllSymbolsW
#else
 #define ServiceGetAllSymbols  ServiceGetAllSymbolsA
#endif
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.1.4.     MqlStrA-    " "    .      -1.  .
EXPFUNC(INT) ServiceGetAllSymbolsMA(      MT::PMQLSTRA pamsSymbols,   //       MqlStrA-    " ".         !
                                                                      //       MQL4.
                                    const INT          nSizeSymbols); //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.1.5.     MqlStrW-    " "    .      -1.  .
EXPFUNC(INT) ServiceGetAllSymbolsMW(      MT::PMQLSTRW pamsSymbols,   //       MqlStrW-    " ".         !
                                                                      //       MQL4.
                                    const INT          nSizeSymbols); //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.1.6.     MqlStr-    " "    .      -1.  .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceGetAllSymbolsM  ServiceGetAllSymbolsMW
#else
 #define ServiceGetAllSymbolsM  ServiceGetAllSymbolsMA
#endif
//==============================================================================================================================================================================================================================================================
// 6.2.       " ".      -1.
EXPFUNC(INT) ServiceGetNumberTools();
//==============================================================================================================================================================================================================================================================
// 6.3.1.       " "    .    ,   -1.    ANSI-.
EXPFUNC(INT) ServiceLineBySymbolA(LPCSTR szSymbol); //     " ".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.3.2.       " "    .    ,   -1.    UNICODE-.
EXPFUNC(INT) ServiceLineBySymbolW(LPCWSTR szSymbol); //     " ".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.3.3.       " "    .    ,   -1.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceLineBySymbol  ServiceLineBySymbolW
#else
 #define ServiceLineBySymbol  ServiceLineBySymbolA
#endif
//==============================================================================================================================================================================================================================================================
// 6.4.1.     ,    " "   ,     . ,   ,     ,  - NULL.
//         .    ANSI-.
EXPFUNC(HWND) ServiceOpenChartA(LPCSTR szSymbol); //     " ".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.4.2.     ,    " "   ,     . ,   ,     ,  - NULL.
//         .    UNICODE-.
EXPFUNC(HWND) ServiceOpenChartW(LPCWSTR szSymbol); //     " ".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.4.3.     ,    " "   ,     . ,   ,     ,  - NULL.
//         .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceOpenChart  ServiceOpenChartW
#else
 #define ServiceOpenChart  ServiceOpenChartA
#endif
//==============================================================================================================================================================================================================================================================
// 6.5.1.     ,    nLine  " ". ,   ,     ,  - NULL.
//               ,    NULL    .    ANSI-.
EXPFUNC(HWND) ServiceOpenChartByIndexA(const INT   nLine,       //     " ",   .
                                             LPSTR szBufSymbol, //       ,     .
                                       const INT   nSizeBuf);   //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.5.2.     ,    nLine  " ". ,   ,     ,  - NULL.
//               ,    NULL    .    ANSI-.
EXPFUNC(HWND) ServiceOpenChartByIndexW(const INT    nLine,       //     " ",   .
                                             LPWSTR szBufSymbol, //       ,     .
                                       const INT    nSizeBuf);   //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.5.3.     ,    nLine  " ". ,   ,     ,  - NULL.
//               ,    NULL    .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceOpenChartByIndex  ServiceOpenChartByIndexW
#else
 #define ServiceOpenChartByIndex  ServiceOpenChartByIndexA
#endif
//==============================================================================================================================================================================================================================================================
// 6.6.1.     ,    " "   ,       . ,   ,     ,  - NULL.
//         .    ANSI-.
EXPFUNC(HWND) ServiceOpenChartSetIndexTfA(LPCSTR szSymbol,    //     " ".
                                          INT    nTimeFrame); //     0  8.
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.6.2.     ,    " "   ,       . ,   ,     ,  - NULL.
//         .    UNICODE-.
EXPFUNC(HWND) ServiceOpenChartSetIndexTfW(LPCWSTR szSymbol,    //     " ".
                                          INT     nTimeFrame); //     0  8.
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.6.3.     ,    " "   ,       . ,   ,     ,  - NULL.
//         .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceOpenChartSetIndexTf  ServiceOpenChartSetIndexTfW
#else
 #define ServiceOpenChartSetIndexTf  ServiceOpenChartSetIndexTfA
#endif
//==============================================================================================================================================================================================================================================================
// 6.7.1.     ,    " "   ,    . ,   ,     ,  - NULL.
//         .    ANSI-.
EXPFUNC(HWND) ServiceOpenChartSetPeriodA(LPCSTR szSymbol, //     " ".
                                         INT    nPeriod); //   .        .
                                                          //   PERIOD_M1       1   1 ;
                                                          //   PERIOD_M5       5   5 ;
                                                          //   PERIOD_M15     15  15 ;
                                                          //   PERIOD_M30     30  30 ;
                                                          //   PERIOD_H1      60   1 ;
                                                          //   PERIOD_H4     240   4 ;
                                                          //   PERIOD_D1    1440   1 ;
                                                          //   PERIOD_W1   10080   1 ;
                                                          //   PERIOD_MN1  43200   1 .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.7.2.     ,    " "   ,    . ,   ,     ,  - NULL.
//         .    UNICODE-.
EXPFUNC(HWND) ServiceOpenChartSetPeriodW(LPCWSTR szSymbol, //     " ".
                                         INT     nPeriod); //   .        .
                                                           //   PERIOD_M1       1   1 ;
                                                           //   PERIOD_M5       5   5 ;
                                                           //   PERIOD_M15     15  15 ;
                                                           //   PERIOD_M30     30  30 ;
                                                           //   PERIOD_H1      60   1 ;
                                                           //   PERIOD_H4     240   4 ;
                                                           //   PERIOD_D1    1440   1 ;
                                                           //   PERIOD_W1   10080   1 ;
                                                           //   PERIOD_MN1  43200   1 .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.7.3.     ,    " "   ,    . ,   ,     ,  - NULL.
//         .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceOpenChartSetPeriod  ServiceOpenChartSetPeriodW
#else
 #define ServiceOpenChartSetPeriod  ServiceOpenChartSetPeriodA
#endif
//==============================================================================================================================================================================================================================================================
// 6.8.1.     ,    " "   ,      . ,   ,     ,  - NULL.
//         .    ANSI-.
EXPFUNC(HWND) ServiceOpenChartSetTfA(LPCSTR szSymbol,     //     " ".
                                     LPCSTR szTimeFrame); //   : ""         NULL     .
                                                          //                          "M1"    1 ;
                                                          //                          "M5"    5 ;
                                                          //                          "M15"  15 ;
                                                          //                          "M30"  30 ;
                                                          //                          "H1"    1 ;
                                                          //                          "H4"    4 ;
                                                          //                          "D1"    1 ;
                                                          //                          "W1"    1 ;
                                                          //                          "MN1"   1 .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.8.2.     ,    " "   ,      . ,   ,     ,  - NULL.
//         .    UNICODE-.
EXPFUNC(HWND) ServiceOpenChartSetTfW(LPCWSTR szSymbol,     //     " ".
                                     LPCWSTR szTimeFrame); //   : ""         NULL     .
                                                           //                          "M1"    1 ;
                                                           //                          "M5"    5 ;
                                                           //                          "M15"  15 ;
                                                           //                          "M30"  30 ;
                                                           //                          "H1"    1 ;
                                                           //                          "H4"    4 ;
                                                           //                          "D1"    1 ;
                                                           //                          "W1"    1 ;
                                                           //                          "MN1"   1 .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.8.3.     ,    " "   ,      . ,   ,     ,  - NULL.
//         .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceOpenChartSetTf  ServiceOpenChartSetTfW
#else
 #define ServiceOpenChartSetTf  ServiceOpenChartSetTfA
#endif
//==============================================================================================================================================================================================================================================================
// 6.9.1.          " ".    ANSI-.
EXPFUNC(LPSTR) ServiceSymbolByLineA(const INT nLine); //     " ",   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.9.2.          " ".    UNICODE-.
EXPFUNC(LPWSTR) ServiceSymbolByLineW(const INT nLine); //     " ",   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.9.3.          " ".      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceSymbolByLine  ServiceSymbolByLineW
#else
 #define ServiceSymbolByLine  ServiceSymbolByLineA
#endif
//
// 7.      "".
//
// 7.1.     "".
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 7.1.1.          .   TRUE,     ,  - FALSE.
EXPFUNC(BOOL) ServiceTerminalBoxCloseByHandle(const HWND hwndMail); //    .
//==============================================================================================================================================================================================================================================================
// 7.1.2.1.         .   TRUE,     ,  - FALSE.    ANSI-.
EXPFUNC(BOOL) ServiceTerminalBoxCloseByNameA(LPCSTR szTitleMail); //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.1.2.2.         .   TRUE,     ,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) ServiceTerminalBoxCloseByNameW(LPCWSTR szTitleMail); //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.1.2.3.         .   TRUE,     ,  - FALSE.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceTerminalBoxCloseByName  ServiceTerminalBoxCloseByNameW
#else
 #define ServiceTerminalBoxCloseByName  ServiceTerminalBoxCloseByNameA
#endif
//==============================================================================================================================================================================================================================================================
// 7.1.3.1.             .       .    ANSI-.
EXPFUNC(LPSTR) ServiceTerminalBoxReadTextA(const HWND hwndMail); //    ,   ServiceMailboxOpen()  ServiceNewsOpen().
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.1.3.2.             .       .    UNICODE-.
EXPFUNC(LPWSTR) ServiceTerminalBoxReadTextW(const HWND hwndMail); //    ,   ServiceMailboxOpen()  ServiceNewsOpen().
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.1.3.3.             .       .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceTerminalBoxReadText  ServiceTerminalBoxReadTextW
#else
 #define ServiceTerminalBoxReadText  ServiceTerminalBoxReadTextA
#endif
//==============================================================================================================================================================================================================================================================
// 7.1.4.1.   HTML-          .       .    ANSI-.
EXPFUNC(LPSTR) ServiceTerminalBoxReadHTMLA(const HWND hwndMail); //    ,   ServiceMailboxOpen()  ServiceNewsOpen().
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.1.4.1.   HTML-          .       .    UNICODE-.
EXPFUNC(LPWSTR) ServiceTerminalBoxReadHTMLW(const HWND hwndMail); //    ,   ServiceMailboxOpen()  ServiceNewsOpen().
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.1.4.3.   HTML-          .       .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceTerminalBoxReadHTML  ServiceTerminalBoxReadHTMLW
#else
 #define ServiceTerminalBoxReadHTML  ServiceTerminalBoxReadHTMLA
#endif
//==============================================================================================================================================================================================================================================================
// 7.1.5.      ""   .
EXPFUNC(VOID) ServiceTerminalSetTabByIndex(const INT nTabId); //    "".
//==============================================================================================================================================================================================================================================================
// 7.1.6.1.      ""   .    ANSI-.
//           .   "" -   -  .    "ServiceTerminalSetTabByIndex()".
EXPFUNC(VOID) ServiceTerminalSetTabByNameA(LPCSTR szNameTab); //    "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.1.6.2.      ""   .    UNICODE-.
//           .   "" -   -  .    "ServiceTerminalSetTabByIndex()".
EXPFUNC(VOID) ServiceTerminalSetTabByNameW(LPCWSTR szNameTab); //    "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.1.6.3.      ""   .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceTerminalSetTabByName  ServiceTerminalSetTabByNameW
#else
 #define ServiceTerminalSetTabByName  ServiceTerminalSetTabByNameA
#endif
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 7.2.    " ".
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 7.2.1.            " "  "".      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceMailboxDelete(const INT nLine); //    " "  "".
//==============================================================================================================================================================================================================================================================
// 7.2.2.1.         " "  ""   .    ANSI-.
EXPFUNC(LPSTR) ServiceMailboxGetFromA(const INT nLine); //    " "  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.2.2.         " "  ""   .    UNICODE-.
EXPFUNC(LPWSTR) ServiceMailboxGetFromW(const INT nLine); //    " "  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.2.3.         " "  ""   .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceMailboxGetFrom  ServiceMailboxGetFromW
#else
 #define ServiceMailboxGetFrom  ServiceMailboxGetFromA
#endif
//==============================================================================================================================================================================================================================================================
// 7.2.3.1.        ,    ( ),   " "  ""  ,     .
//            -1,    .    ANSI-.
EXPFUNC(INT) ServiceMailboxGetLineA(LPCSTR    szDataTime, //    "YYYY.MM.DD HH:MM".           .
                                    LPCSTR    szFrom,     //   .       .
                                    LPCSTR    szTheme,    //  .       .
                                    const INT nStart,     //      ( ),     .    .
                                    const INT nCount);    //    .    -1,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.3.2.        ,    ( ),   " "  ""  ,     .
//            -1,    .    UNICODE-.
EXPFUNC(INT) ServiceMailboxGetLineW(LPCWSTR   szDataTime, //    "YYYY.MM.DD HH:MM".           .
                                    LPCWSTR   szFrom,     //   .       .
                                    LPCWSTR   szTheme,    //  .       .
                                    const INT nStart,     //      ( ),     .    .
                                    const INT nCount);    //    .    -1,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.3.3.        ,    ( ),   " "  ""  ,     .
//            -1,    .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceMailboxGetLine  ServiceMailboxGetLineW
#else
 #define ServiceMailboxGetLine  ServiceMailboxGetLineA
#endif
//==============================================================================================================================================================================================================================================================
// 7.2.4.1.        " "  ""        "YYYY.MM.DD HH:MM".    ANSI-.
EXPFUNC(LPSTR) ServiceMailboxGetStringTimeA(const INT nLine); //    " "  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.4.2.        " "  ""        "YYYY.MM.DD HH:MM".    UNICODE-.
EXPFUNC(LPWSTR) ServiceMailboxGetStringTimeW(const INT nLine); //    " "  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.4.3.        " "  ""        "YYYY.MM.DD HH:MM".      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceMailboxGetStringTime  ServiceMailboxGetStringTimeW
#else
 #define ServiceMailboxGetStringTime  ServiceMailboxGetStringTimeA
#endif
//==============================================================================================================================================================================================================================================================
// 7.2.5.        " "  ""      UNIXTIME.
EXPFUNC(__time64_t) ServiceMailboxGetTime(const INT nLine); //    " "  "".
//==============================================================================================================================================================================================================================================================
// 7.2.6.1.        " "  ""   .    ANSI-.
EXPFUNC(LPSTR) ServiceMailboxGetThemeA(const INT nLine); //    " "  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.6.2.        " "  ""   .    UNICODE-.
EXPFUNC(LPWSTR) ServiceMailboxGetThemeW(const INT nLine); //    " "  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.6.3.        " "  ""   .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceMailboxGetTheme  ServiceMailboxGetThemeW
#else
 #define ServiceMailboxGetTheme  ServiceMailboxGetThemeA
#endif
//==============================================================================================================================================================================================================================================================
// 7.2.7.             " "  ""      .
//          ,        "ServiceSetTerminalTab()". ,    .
EXPFUNC(HWND) ServiceMailboxOpen(const INT nLine); //    " "  "".
//==============================================================================================================================================================================================================================================================
// 7.2.8.        " "  "".
EXPFUNC(INT) ServiceMailboxRows();
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 7.3.    "".
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 7.3.1.        ""  "".
EXPFUNC(INT) ServiceNewsColumns();
//==============================================================================================================================================================================================================================================================
// 7.3.2.1.       ""  ""   .    ANSI-.
EXPFUNC(LPSTR) ServiceNewsGetCategoryA(const INT nLine); //    ""  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.2.2.       ""  ""   .    UNICODE-.
EXPFUNC(LPWSTR) ServiceNewsGetCategoryW(const INT nLine); //    ""  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.3.3.      ""  ""   .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceNewsGetCategory  ServiceNewsGetCategoryW
#else
 #define ServiceNewsGetCategory  ServiceNewsGetCategoryA
#endif
//==============================================================================================================================================================================================================================================================
// 7.3.3.1.       ,    ( ),   ""  ""  ,     .
//            -1,    .    ANSI-.
EXPFUNC(INT) ServiceNewsGetLineA(LPCSTR    szDataTime, //    "YYYY.MM.DD HH:MM".           .
                                 LPCSTR    szTheme,    //  .       .
                                 const INT nStart,     //      ( ),     .    .
                                 const INT nCount);    //    .    -1,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.3.2.       ,    ( ),   ""  ""  ,     .
//            -1,    .    UNICODE-.
EXPFUNC(INT) ServiceNewsGetLineW(LPCWSTR   szDataTime, //    "YYYY.MM.DD HH:MM".           .
                                 LPCWSTR   szTheme,    //  .       .
                                 const INT nStart,     //      ( ),     .    .
                                 const INT nCount);    //    .    -1,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.3.3.       ,    ( ),   ""  ""  ,     .
//            -1,    .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceNewsGetLine  ServiceNewsGetLineW
#else
 #define ServiceNewsGetLine  ServiceNewsGetLineA
#endif
//==============================================================================================================================================================================================================================================================
// 7.3.4.1.       ""  ""        "YYYY.MM.DD HH:MM".    ANSI-.
EXPFUNC(LPSTR) ServiceNewsGetStringTimeA(const INT nLine); //    ""  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.4.2.       ""  ""        "YYYY.MM.DD HH:MM".    UNICODE-.
EXPFUNC(LPWSTR) ServiceNewsGetStringTimeW(const INT nLine); //    ""  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.4.3.       ""  ""        "YYYY.MM.DD HH:MM".      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceNewsGetStringTime  ServiceNewsGetStringTimeW
#else
 #define ServiceNewsGetStringTime  ServiceNewsGetStringTimeA
#endif
//==============================================================================================================================================================================================================================================================
// 7.3.5.1.       ""  ""   .    ANSI-.
EXPFUNC(LPSTR) ServiceNewsGetThemeA(const INT nLine); //    ""  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.5.2.       ""  ""   .    UNICODE-.
EXPFUNC(LPWSTR) ServiceNewsGetThemeW(const INT nLine); //    ""  "".
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.5.3.       ""  ""   .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceNewsGetTheme  ServiceNewsGetThemeW
#else
 #define ServiceNewsGetTheme  ServiceNewsGetThemeA
#endif
//==============================================================================================================================================================================================================================================================
// 7.3.6.       ""  ""      UNIXTIME.
EXPFUNC(__time64_t) ServiceNewsGetTime(const INT nLine); //    ""  "".
//==============================================================================================================================================================================================================================================================
// 7.3.7.            ""  ""       .
//          ,        "ServiceSetTerminalTab()". ,    .
EXPFUNC(HWND) ServiceNewsOpen(const INT nLine); //    ""  "".
//==============================================================================================================================================================================================================================================================
// 7.3.8.        ""  "".
EXPFUNC(INT) ServiceNewsRows();
//
// 8.     MQL4.
//
// 8.1.      .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceDeleteExpert(const HWND hwndChart); //    ,  .
//==============================================================================================================================================================================================================================================================
// 8.2.1.     ANSI-    .  .
EXPFUNC(VOID) ServiceDeleteIndicatorsByNameA(const HWND hwndChart,           //   ,   .
                                             const INT  nWindow,             //     .  -1,      .
                                             LPCSTR*    paszNamesIndicators, //     ANSI-  .
                                             const INT  nSize);              //  .    ANSI-   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.2.2.     UNICODE-    .  .
EXPFUNC(VOID) ServiceDeleteIndicatorsByNameW(const HWND hwndChart,           //   ,   .
                                             const INT  nWindow,             //     .  -1,      .
                                             LPCWSTR*   paszNamesIndicators, //     UNICODE-  .
                                             const INT  nSize);              //  .    UNICODE-   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.2.3.            .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceDeleteIndicatorsByName  ServiceDeleteIndicatorsByNameW
#else
 #define ServiceDeleteIndicatorsByName  ServiceDeleteIndicatorsByNameA
#endif
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.2.4.     MqlStrA-    .  .
EXPFUNC(VOID) ServiceDeleteIndicatorsByNameMA(const HWND         hwndChart,           //   ,   .
                                              const INT          nWindow,             //     .  -1,      .
                                              const MT::PMQLSTRA pamsNamesIndicators, //    MqlStrA-  .
                                              const INT          nSize);              //  .     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.2.5.     MqlStrW-    .  .
EXPFUNC(VOID) ServiceDeleteIndicatorsByNameMW(const HWND         hwndChart,           //   ,   .
                                              const INT          nWindow,             //     .  -1,      .
                                              const MT::PMQLSTRW pamsNamesIndicators, //    MqlStrW-  .
                                              const INT          nSize);              //  .     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.2.6.     MqlStr-    .  .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceDeleteIndicatorsByNameM  ServiceDeleteIndicatorsByNameMW
#else
 #define ServiceDeleteIndicatorsByNameM  ServiceDeleteIndicatorsByNameMA
#endif
//==============================================================================================================================================================================================================================================================
// 8.3.      .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceDeleteScript(const HWND hwndChart); //    ,  .
//==============================================================================================================================================================================================================================================================
// 8.4.              ,   ,  - NULL.
EXPFUNC(HWND) ServiceDialogScript(BOOL bInstruction); //      : TRUE -  , FALSE -   .
//==============================================================================================================================================================================================================================================================
// 8.5.1.   ANSI-     .            "nWindow",  .
EXPFUNC(INT) ServiceGetNamesIndicatorsA(const HWND   hwndChart,      //   ,   .
                                        const INT    nWindow,        //  .  -1,       .
                                              LPSTR* paszIndicators, //       ANSI-    .
                                        const INT    nSize0,         //      (   ).
                                        const INT    nSize1);        //     .     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.5.2.   UNICODE-     .            "nWindow",  .
EXPFUNC(INT) ServiceGetNamesIndicatorsW(const HWND    hwndChart,      //   ,   .
                                        const INT     nWindow,        //  .  -1,       .
                                              LPWSTR* paszIndicators, //       UNICODE-    .
                                        const INT     nSize0,         //      (   ).
                                        const INT     nSize1);        //     .     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.5.3.            .            "nWindow",  .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceGetNamesIndicators  ServiceGetNamesIndicatorsW
#else
 #define ServiceGetNamesIndicators  ServiceGetNamesIndicatorsA
#endif
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.5.4.   MqlStrA-     .            "nWindow",  .
EXPFUNC(INT) ServiceGetNamesIndicatorsMA(const HWND         hwndChart,      //   ,   .
                                         const INT          nWindow,        //  .  -1,       .
                                               MT::PMQLSTRA pamsIndicators, //      MqlStrA- .         !
                                                                            //       MQL4.
                                         const INT          nSize);         //   "amsIndicatorName[]"    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.5.5.   MqlStrW-     .            "nWindow",  .
EXPFUNC(INT) ServiceGetNamesIndicatorsMW(const HWND         hwndChart,      //   ,   .
                                         const INT          nWindow,        //  .  -1,       .
                                               MT::PMQLSTRW pamsIndicators, //      MqlStrW- .         !
                                                                            //       MQL4.
                                         const INT          nSize);         //   "amsIndicatorName[]"    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.5.6.   MqlStr-     .            "nWindow",  .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceGetNamesIndicatorsM  ServiceGetNamesIndicatorsMW
#else
 #define ServiceGetNamesIndicatorsM  ServiceGetNamesIndicatorsMA
#endif
//==============================================================================================================================================================================================================================================================
// 8.6.1.   TRUE,     ,  - FALSE.    ANSI-.
EXPFUNC(BOOL) ServiceIsPropertiesExpertA(LPCSTR szNameExpert); //  ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.6.2.   TRUE,     ,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) ServiceIsPropertiesExpertW(LPCWSTR szNameExpert); //  ,     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.6.3.   TRUE,     ,  - FALSE.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceIsPropertiesExpert  ServiceIsPropertiesExpertW
#else
 #define ServiceIsPropertiesExpert  ServiceIsPropertiesExpertA
#endif
//==============================================================================================================================================================================================================================================================
// 8.7.     .       2,5 .        ,   FALSE.
EXPFUNC(BOOL) ServiceListIndicators(const HWND hwndChart); //    ,      .
//==============================================================================================================================================================================================================================================================
// 8.8.1.          .    ANSI-.
EXPFUNC(VOID) ServiceLoadCustomIndicatorA(const HWND hwndChart,       //    ,   .
                                          LPCSTR     szNameIndicator, //   .
                                          const BOOL bOK);            //   ,      .
                                                                      //   TRUE  -    "OK" .
                                                                      //   FALSE -    "OK" .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.8.2.          .    UNICODE-.
EXPFUNC(VOID) ServiceLoadCustomIndicatorW(const HWND hwndChart,       //    ,   .
                                          LPCWSTR    szNameIndicator, //   .
                                          const BOOL bOK);            //   ,      .
                                                                      //   TRUE  -    "OK" .
                                                                      //   FALSE -    "OK" .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.8.3.          .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceLoadCustomIndicator  ServiceLoadCustomIndicatorW
#else
 #define ServiceLoadCustomIndicator  ServiceLoadCustomIndicatorA
#endif
//==============================================================================================================================================================================================================================================================
// 8.9.1.         .    ANSI-.
EXPFUNC(VOID) ServiceLoadExpertA(const HWND hwndChart,    //    ,   .
                                 LPCSTR     szNameExpert, //   .
                                 const BOOL bOK);         //   ,      .
                                                          //   TRUE  -    "OK" .
                                                          //   FALSE -    "OK" .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.9.2.         .    UNICODE-.
EXPFUNC(VOID) ServiceLoadExpertW(const HWND hwndChart,    //    ,   .
                                 LPCWSTR    szNameExpert, //   .
                                 const BOOL bOK);         //   ,      .
                                                          //   TRUE  -    "OK" .
                                                          //   FALSE -    "OK" .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.9.3.         .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceLoadExpert  ServiceLoadExpertW
#else
 #define ServiceLoadExpert  ServiceLoadExpertA
#endif
//==============================================================================================================================================================================================================================================================
// 8.10.1.         .    ANSI-.
EXPFUNC(VOID) ServiceLoadScriptA(const HWND hwndChart,    //    ,   .
                                 LPCSTR     szNameScript, //   .
                                 const BOOL bOK);         //   ,      .
                                                          //   TRUE  -    "OK" .
                                                          //   FALSE -    "OK" .
                                                          //        !
                                                          //               -        .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.10.2.         .    UNICODE-.
EXPFUNC(VOID) ServiceLoadScriptW(const HWND hwndChart,    //    ,   .
                                 LPCWSTR    szNameScript, //   .
                                 const BOOL bOK);         //   ,      .
                                                          //   TRUE  -    "OK" .
                                                          //   FALSE -    "OK" .
                                                          //        !
                                                          //               -        .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.10.3.         .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceLoadScript  ServiceLoadScriptW
#else
 #define ServiceLoadScript  ServiceLoadScriptA
#endif
//==============================================================================================================================================================================================================================================================
// 8.11.1.          .    ANSI-.
EXPFUNC(VOID) ServiceLoadStdIndicatorA(const HWND hwndChart,       //    ,   .
                                       LPCSTR     szNameIndicator, //   .
                                       const BOOL bOK);            //   ,      .
                                                                   //   TRUE  -    "OK" .
                                                                   //   FALSE -    "OK" .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.11.2.          .    UNICODE-.
EXPFUNC(VOID) ServiceLoadStdIndicatorW(const HWND hwndChart,       //    ,   .
                                       LPCWSTR    szNameIndicator, //   .
                                       const BOOL bOK);            //   ,      .
                                                                   //   TRUE  -    "OK" .
                                                                   //   FALSE -    "OK" .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.11.3.          .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceLoadStdIndicator  ServiceLoadStdIndicatorW
#else
 #define ServiceLoadStdIndicator  ServiceLoadStdIndicatorA
#endif
//==============================================================================================================================================================================================================================================================
// 8.12.     .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServicePropertiesExpert(const HWND hwndChart); //    ,      .
//==============================================================================================================================================================================================================================================================
// 8.13.  / ,   "".
EXPFUNC(VOID) ServiceSetExperts();
//
// 9.        .
//
// 9.1.1.   ,    .    ANSI-.
EXPFUNC(VOID) ServiceLoginApplyA(const INT  nLogin,       //  .      (nLogin = 0),      --.
                                 LPCSTR     szPassword,   // .       ,     .
                                 LPCSTR     szNameServer, //  .        ,     .
                                 const BOOL bStoreInfo);  //    - TRUE.     - FALSE.
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 9.1.2.   ,    .    UNICODE-.
EXPFUNC(VOID) ServiceLoginApplyW(const INT  nLogin,       //  .      (nLogin = 0),      --.
                                 LPCWSTR    szPassword,   // .       ,     .
                                 LPCWSTR    szNameServer, //  .        ,     .
                                 const BOOL bStoreInfo);  //    - TRUE.     - FALSE.
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 9.1.3.   ,    .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceLoginApply  ServiceLoginApplyW
#else
 #define ServiceLoginApply  ServiceLoginApplyA
#endif
//==============================================================================================================================================================================================================================================================
// 9.2.        .             ,  - NULL.
EXPFUNC(HWND) ServiceLoginBoxHandle();
//==============================================================================================================================================================================================================================================================
// 9.3.1.     (     )  .    ANSI-.
EXPFUNC(LPSTR) ServiceLoginNameServerA();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 9.3.2.     (     )  .    UNICODE-.
EXPFUNC(LPWSTR) ServiceLoginNameServerW();
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 9.3.3.     (     )  .      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceLoginNameServer  ServiceLoginNameServerW
#else
 #define ServiceLoginNameServer  ServiceLoginNameServerA
#endif
//
//10.  .
//
//10.1.    .      2,5 ,     .        ,  .
EXPFUNC(VOID) ServiceAlertClose();
//==============================================================================================================================================================================================================================================================
//10.2.   TRUE,    ,  - FALSE.
EXPFUNC(BOOL) ServiceAlertIs();
//==============================================================================================================================================================================================================================================================
//10.3.   ,     ,   ,     ,  ,    .
//          ,     ,      ,    .
EXPFUNC(VOID) ServiceGetCursorInfo(      INT* paiCursorInfo, //       .
                                                             // paiCursorInfo[0] -   ,   .
                                                             // paiCursorInfo[1] -   X .
                                                             // paiCursorInfo[2] -   Y .
                                                             // paiCursorInfo[3] -   X .
                                                             // paiCursorInfo[4] -   Y .
                                                             // paiCursorInfo[5] -  ,    .    -1  0xFFFFFFFF,       .
                                    const INT  nSize);       //  .
//==============================================================================================================================================================================================================================================================
//10.4.1.      "HOME"           " ".
//             0,    1.      -1   .
//         szScriptSensor      .      nLoading, bMode, abScanTF   .
//         bMode, abScanTF      nLoading = MLQ_CONTINUED.    ANSI-.
EXPFUNC(INT) ServiceLoaderQuotesA(const INT   nLoading,        //   :
                                                               //   MLQ_STOP_TF                     "bMode";
                                                               //   MLQ_CONTINUED       ;
                                                               //   MLQ_FINISH       .
                                  const BOOL  bHowScanTools,   //   :
                                                               //   TRUE  -        ;
                                                               //   FALSE -        .
                                  const PBOOL abScanTF,        //     .       9 .
                                  LPCSTR      szScriptSensor); //  -             .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//10.4.2.      "HOME"           " ".
//             0,    1.      -1   .
//         szScriptSensor      .      nLoading, bMode, abScanTF   .
//         bMode, abScanTF      nLoading = MLQ_CONTINUED.    UNICODE-.
EXPFUNC(INT) ServiceLoaderQuotesW(const INT   nLoading,        //   :
                                                               //   MLQ_STOP_TF                     "bMode";
                                                               //   MLQ_CONTINUED       ;
                                                               //   MLQ_FINISH       .
                                  const BOOL  bHowScanTools,   //   :
                                                               //   TRUE  -        ;
                                                               //   FALSE -        .
                                  const PBOOL abScanTF,        //     .       9 .
                                  LPCWSTR     szScriptSensor); //  -             .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//10.4.3.      "HOME"           " ".
//             0,    1.      -1   .
//         szNameScript      .      nLoading, bMode, abScanTF   .
//         bMode, abScanTF      nLoading = MLQ_CONTINUED.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceLoaderQuotes  ServiceLoaderQuotesW
#else
 #define ServiceLoaderQuotes  ServiceLoaderQuotesA
#endif
//==============================================================================================================================================================================================================================================================
//10.5.          .
EXPFUNC(HWND) ServiceOpenDeletetChart(const INT nChart); //      .
//==============================================================================================================================================================================================================================================================
//10.6.1.     . ,   ,     ,  - NULL.    ANSI-.
EXPFUNC(HWND) ServiceOpenOfflineChartA(LPCSTR szSymbol,  //  .
                                       LPCSTR szPeriod); // . : M1, M2, M5, H1, H12, Daily, Weekly, Monthly, D90, D360, D1440.
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//10.6.2.     . ,   ,     ,  - NULL.    UNICODE-.
EXPFUNC(HWND) ServiceOpenOfflineChartW(LPCWSTR szSymbol,  //  .
                                       LPCWSTR szPeriod); // . : M1, M2, M5, H1, H12, Daily, Weekly, Monthly, D90, D360, D1440.
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//10.6.3.     . ,   ,     ,  - NULL.      .
#if defined(UNICODE) || defined(_UNICODE)
 #define ServiceOpenOfflineChart  ServiceOpenOfflineChartW
#else
 #define ServiceOpenOfflineChart  ServiceOpenOfflineChartA
#endif
//==============================================================================================================================================================================================================================================================
//10.7.   .      TRUE,  - FALSE.
EXPFUNC(BOOL) ServiceRescanServers();
//==============================================================================================================================================================================================================================================================
//10.8.        "ServiceLoaderQuotes()".         ,      .
EXPFUNC(VOID) ServiceSensorLoadQuotes(const HWND hwndChart); //    ,     .
//